%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                    PSG Type    PSG Object           Location in Problem Statement                                                             Class
%pmatrix_obj_1_data        data        pmatrix_obj_1        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    double
%pmatrix_obj_1_vars        vars        pmatrix_obj_1        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    cell
%pmatrix_obj_2_data        data        pmatrix_obj_2        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    double
%pmatrix_obj_2_vars        vars        pmatrix_obj_2        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    cell
%pmatrix_obj_3_data        data        pmatrix_obj_3        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    double
%pmatrix_obj_3_vars        vars        pmatrix_obj_3        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    cell
%pmatrix_obj_4_data        data        pmatrix_obj_4        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    double
%pmatrix_obj_4_vars        vars        pmatrix_obj_4        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    cell
%pmatrix_obj_5_data        data        pmatrix_obj_5        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    double
%pmatrix_obj_5_vars        vars        pmatrix_obj_5        -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)    cell
%parameter_bound_data      data        parameter_bound      Box: >= parameter_bound, <= parameter_bound_1                                             double
%parameter_bound_1_data    data        parameter_bound_1    Box: >= parameter_bound, <= parameter_bound_1                                             double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(pmatrix_obj_1_data,pmatrix_obj_1_vars,pmatrix_obj_2_data,pmatrix_obj_2_vars,pmatrix_obj_3_data,pmatrix_obj_3_vars,pmatrix_obj_4_data,pmatrix_obj_4_vars,pmatrix_obj_5_data,pmatrix_obj_5_vars,parameter_bound_data,parameter_bound_1_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj_1',pmatrix_obj_1_vars,pmatrix_obj_1_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj_2',pmatrix_obj_2_vars,pmatrix_obj_2_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj_3',pmatrix_obj_3_vars,pmatrix_obj_3_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj_4',pmatrix_obj_4_vars,pmatrix_obj_4_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_obj_5',pmatrix_obj_5_vars,pmatrix_obj_5_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  -avg_max_risk_g(pmatrix_obj_1,pmatrix_obj_2,pmatrix_obj_3,pmatrix_obj_4,pmatrix_obj_5)',...
'Box: >= parameter_bound, <= parameter_bound_1',...
'',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

